*--             : MusTest.prg
*--             : Jay Parsons and Ken Chan

*--             : demo of Musclick.bin  Version 1.1
*--             : 07/06/92

*--             : You may substitute any mouse on/off bins and calls
*--             : for the ones to JPMOUSE.

*-- Init
clear
cSetEsc = set( "ESCAPE" )
set escape on
load JPMOUSE
call JPMOUSE WITH "?"
load MUSCLICK
*-- Mouse click "presses" ESC.
*-- We chose ESC because it's the only key that will get dBASE's
*-- attention during the DIR.  It _will_ terminate the active listing.
cSuccess = call( "MUSCLICK", "I", chr( 27 ))
if cSuccess = "F"
  ? "### Unable to install mouse handler"
  ?
  cancel
endif


*-- Main routine
define window wDir from  5,0 to 20,79
activate window wDir
? "Type name of directory with a lot of files in it (ENTER for current):"
accept "> " TO cdir
if "" # cDir
   cDir = cDir + iif( right( cDir, 1 ) = "\", "*.*", "\*.*" )
endif
activate screen
*-- Psuedo-buttons
@ 22, 8 say "Red"   picture "@i xxxxxxxxxx" color r/w
@ 22,26 say "Green" picture "@i xxxxxxxxxx" color g/w
@ 22,44 say "Blue"  picture "@i xxxxxxxxxx" color b/w
@ 22,62 say "Stop!" picture "@i xxxxxxxxxx" color gr+/w
*-- Centered message
cCtrTempl = "@i " + replicate( "x", 80 )
@  2, 0 say "Try changing the colors with the buttons below" picture cCtrTempl
@  3, 0 say "Notice that the colors can change in the middle of the listing" picture cCtrTempl
activate window wDir
set color to w+/r
clear
lLoop = .t.
call JPMOUSE with "+"
*-- Look for our event
on escape do KeyTrap
*-- Main loop
do while lLoop
  dir &cdir.
enddo
*-- That's it.  Clean up and shut down
call JPMOUSE with "-"
on escape
activate screen
release window wDir

*-- Shutdown
CALL MUSCLICK WITH "U"
call JPMOUSE WITH "?"
clear
call JPMOUSE with "+"
release modules
set escape &cSetEsc.
RETURN



PROCEDURE KeyTrap
  private cMRow, cMCol, nMRow, nMCol
  *-- Get row and column
  store chr( 255 ) to cMRow, cMCol
  call MUSCLICK with cMRow, cMCol
  *-- Convert CHRs to their ASCII values
  nMRow = asc( cMRow )
  nMCol = asc( cMCol )
  activate screen
  activate window wDir
  *-- What it our mouse event?
  if nMRow < 200
    *-- Yep.  See if we pushed any buttons
    if nMRow = 22
      do case
        *-- Red
        case nMCol >=  8 .and. nMCol < 18
          set color to w+/r
          @  0, 0 fill to 13,77 color w+/r
        *-- Green
        case nMCol >= 26 .and. nMCol < 36
          set color to w+/g
          @  0, 0 fill to 13,77 color w+/g
        *-- Blue
        case nMCol >= 44 .and. nMCol < 54
          set color to w+/b
          @  0, 0 fill to 13,77 color w+/b
        *-- Stop!
        case nMCol >= 62 .and. nMCol < 72
          lLoop = .f.
      endcase
    endif
  else
    *-- The real Esc key was pressed.  Stop program
    lLoop = .f.
  endif
RETURN

